package com.mongo.demo.controller;

import com.mongo.demo.dto.EmployeeDto;
import com.mongo.demo.entity.Employee;
import com.mongo.demo.service.EmployeeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import reactor.core.publisher.Mono;

import java.util.List;

@RestController
public class EmployeeController {

    @Autowired
    private EmployeeService service;

    @GetMapping("/employeesDetails")
    public Mono<List<Employee>> getEmployeesDetails(){
        return service.getEmployeesDetails();
    }

    @GetMapping("/employeeDetails/{id}")
    public Mono<EmployeeDto> getEmployeeDetails(@PathVariable String id){
        return service.getEmployeeDetails(id);
    }

    @PostMapping("/createEmployee")
    public Mono<EmployeeDto> createEmployee(@RequestBody Mono<EmployeeDto> employeeDtoMono){
        return service.createEmployee(employeeDtoMono);
    }

    @DeleteMapping("/deleteEmployee/{id}")
    public Mono<String> deleteEmployee(@PathVariable String id){
        return service.deleteEmployee(id);
    }


}
